## ros-indigo-threemxl 0.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(threemxl)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

find_package(catkin   REQUIRED COMPONENTS roscpp shared_serial)
find_package(Readline REQUIRED)

# Check for libftdipp
find_package(PkgConfig REQUIRED)
pkg_check_modules(LIBFTDIPP QUIET libftdipp)
if (LIBFTDIPP_FOUND)
  set(FTDI_SOURCE src/LxFTDI.cpp)
  message("-- using FTDI")
endif()

# Get tinyxml and muparser
pkg_check_modules(TINYXML REQUIRED tinyxml)
pkg_check_modules(MUPARSER REQUIRED muparser)

catkin_package(
  INCLUDE_DIRS   include
  LIBRARIES      ${PROJECT_NAME} ${TINYXML_LIBRARIES} ${MUPARSER_LIBRARIES} ${LIBFTDIPP_LIBRARIES}
  CATKIN_DEPENDS roscpp
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(include ${catkin_INCLUDE_DIRS} ${READLINE_INCLUDE_DIR} ${TINYXML_INCLUDE_DIRS} ${MUPARSER_INCLUDE_DIRS} ${LIBFTDIPP_INCLUDE_DIRS})

# Setup DBL repository stuff
set(WORKSPACE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

# Build relevant DBL repo things
set(TARGET ${PROJECT_NAME}_dbl)
add_library(${TARGET} STATIC src/dummy.cpp)
include(${WORKSPACE_DIR}/dbl/platform/hardware/dynamixel/dynamixel.cmake)
include(${WORKSPACE_DIR}/dbl/platform/io/logging/stdlogging.cmake)

# Main threemxl library
add_library(${PROJECT_NAME} src/CDxlROSPacketHandler.cpp ${FTDI_SOURCE})
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    target_link_libraries(${PROJECT_NAME} LINK_PRIVATE -force_load configuration -force_load half -force_load serial -force_load stdlogging -force_load dynamixel
                                          LINK_PUBLIC  ${catkin_LIBRARIES} ${LIBFTDIPP_LDFLAGS} ${TINYXML_LDFLAGS} ${MUPARSER_LDFLAGS})
else()
    set(DBL_STATIC_LIBS -L${CMAKE_LIBRARY_OUTPUT_DIRECTORY} configuration half serial stdlogging dynamixel)
    target_link_libraries(${PROJECT_NAME} LINK_PRIVATE -Wl,-whole-archive ${DBL_STATIC_LIBS} -Wl,-no-whole-archive
                                          LINK_PUBLIC  ${catkin_LIBRARIES} ${LIBFTDIPP_LDFLAGS} ${TINYXML_LDFLAGS} ${MUPARSER_LDFLAGS})
endif()

# Console
add_executable(console src/console.cpp)
target_link_libraries(console ${PROJECT_NAME} ${READLINE_LIBRARY})

# Example program for hand setup
add_executable(example src/example.cpp)
target_link_libraries(example ${PROJECT_NAME})

#############
## Install ##
#############

install(TARGETS ${PROJECT_NAME} console example
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION     ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING
  PATTERN         "*.h"
  PATTERN         "*.hpp"
  PATTERN         ".svn" EXCLUDE
  PATTERN         "console.h" EXCLUDE
  PATTERN         "example.h" EXCLUDE
)

=== dbl/externals/half/CMakeLists.txt ===
#
# CMake build file for half library
# Wouter Caarls <w.caarls@tudelft.nl>
#
# 29-03-2010 (wcaarls): Initial revision
#

# Preamble
PROJECT(half)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Setup project environment
GET_FILENAME_COMPONENT(BASE_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
SET(WORKSPACE_DIR ${BASE_DIR}/../../..)
SET(TARGET half)

# Specify sources
ADD_LIBRARY(${TARGET} STATIC ${BASE_DIR}/half.cpp)

=== dbl/platform/hardware/dynamixel/CMakeLists.txt ===
#
# CMake build file for dynamixel library
# Wouter Caarls <w.caarls@tudelft.nl>
#
# 30-03-2010 (wcaarls): Initial revision
# 15-04-2010 (evbreda): Devided code over several files
# 16-06-2010 (evanbreda): can choose between rt an non rt now
#

#SET(XENOMAI 1)

# Preamble
PROJECT(dynamixel)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Setup project environment
GET_FILENAME_COMPONENT(BASE_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
SET(WORKSPACE_DIR ${BASE_DIR}/../../../..)
SET(TARGET dynamixel)

ADD_LIBRARY(${TARGET} STATIC ${BASE_DIR}/CDxlCom.cpp
                      ${BASE_DIR}/CDxlSerialPacketHandler.cpp
                      ${BASE_DIR}/CDxlGeneric.cpp
                      ${BASE_DIR}/dynamixel/Dynamixel.cpp
                      ${BASE_DIR}/CDxlConfig.cpp
                      ${BASE_DIR}/CDxlGroup.cpp
                      ${BASE_DIR}/3mxl/3mxl.cpp
           )

INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/logging.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/hardware/serial/serial.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/configuration/configuration.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/externals/half/half.cmake)

=== dbl/platform/hardware/serial/CMakeLists.txt ===
#
# CMake build file for serial library
# Wouter Caarls <w.caarls@tudelft.nl>
#
# 30-03-2010 (wcaarls): Initial revision
# 16-06-2010 (evanbreda): can choose between rt an non rt now

# Preamble
PROJECT(serial)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Setup project environment
GET_FILENAME_COMPONENT(BASE_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
SET(WORKSPACE_DIR ${BASE_DIR}/../../../..)
SET(TARGET serial)

# Specify sources
ADD_LIBRARY(${TARGET} STATIC ${BASE_DIR}/LxSerial.cpp)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/logging.cmake)

=== dbl/platform/io/configuration/CMakeLists.txt ===
#
# CMake build file for configuration library
# Wouter Caarls <w.caarls@tudelft.nl>
#
# 29-03-2010 (wcaarls): Initial revision
#

# Preamble
PROJECT(configuration)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Setup project environment
GET_FILENAME_COMPONENT(BASE_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
SET(WORKSPACE_DIR ${BASE_DIR}/../../../..)
SET(TARGET configuration)

# Specify sources
ADD_LIBRARY(${TARGET} STATIC ${BASE_DIR}/Configuration.cpp
                      ${BASE_DIR}/XMLConfiguration.cpp
           )

INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/logging.cmake)

=== dbl/platform/hardware/dynamixel/ftditests/CMakeLists.txt ===
#
# CMake build file for dynamixel-tests using FTDI serial communication
# Wouter Caarls <w.caarls@tudelft.nl>
#
# 30-03-2010 (wcaarls): Initial revision
#

# Preamble
PROJECT(dynamixel-tests)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
SET(CMAKE_BUILD_TYPE Release)



# Setup project environment
GET_FILENAME_COMPONENT(BASE_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
SET(WORKSPACE_DIR ${BASE_DIR}/../../../../..)

# dxl-all
SET(TARGET dxl-all)
ADD_EXECUTABLE(${TARGET} ${BASE_DIR}/dxl-all.cpp)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/include.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/hardware/dynamixel/dynamixel.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/stdlogging.cmake)

# dxl-goto
SET(TARGET dxl-goto)
ADD_EXECUTABLE(${TARGET} ${BASE_DIR}/dxl-goto.cpp)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/include.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/stdlogging.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/hardware/dynamixel/dynamixel.cmake)

# dxl-voltage
SET(TARGET dxl-voltage)
ADD_EXECUTABLE(${TARGET} ${BASE_DIR}/dxl-voltage.cpp)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/include.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/stdlogging.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/math/math.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/hardware/dynamixel/dynamixel.cmake)

# dxl-changeid
SET(TARGET dxl-changeid)
ADD_EXECUTABLE(${TARGET} ${BASE_DIR}/dxl-changeid.cpp)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/include.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/hardware/dynamixel/dynamixel.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/stdlogging.cmake)

# testdxlmultiport
SET(TARGET testdxlmultiport)
ADD_EXECUTABLE(${TARGET} ${BASE_DIR}/testdxlmultiport.cpp)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/stdlogging.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/hardware/dynamixel/dynamixel.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/threading/threading.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/time/time.cmake)

=== dbl/platform/hardware/dynamixel/non_rt_tests/CMakeLists.txt ===
#
# CMake build file for dynamixel-tests
# Wouter Caarls <w.caarls@tudelft.nl>
#
# 30-03-2010 (wcaarls): Initial revision
# 01-04-2010 (evanbreda): changed way xenomai is linked to this project
# 11-08-2011 (evanbreda): nonrt version

ADD_DEFINITIONS(-DDEBUG)

# Preamble
PROJECT(dynamixel-tests-nonrt)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
SET(CMAKE_BUILD_TYPE Release)



# Setup project environment
GET_FILENAME_COMPONENT(BASE_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
SET(WORKSPACE_DIR ${BASE_DIR}/../../../../..)


# 3mxl-all
SET(TARGET 3mxl-all)
ADD_EXECUTABLE(${TARGET} ${BASE_DIR}/3mxl-all.cpp)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/stdlogging.cmake)
INCLUDE (${WORKSPACE_DIR}/dbl/platform/hardware/dynamixel/dynamixel.cmake)

=== dbl/platform/io/logging/std/CMakeLists.txt ===
#
# CMake build file for standard logging library
# Wouter Caarls <w.caarls@tudelft.nl>
#
# 15-04-2010 (wcaarls): Initial revision
#

# Preamble
PROJECT(stdloggig)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Setup project environment
GET_FILENAME_COMPONENT(BASE_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
SET(WORKSPACE_DIR ${BASE_DIR}/../../../../..)
SET(TARGET stdlogging)

# Specify sources
ADD_LIBRARY(${TARGET} STATIC ${BASE_DIR}/StdLog2.cpp
           )

INCLUDE (${WORKSPACE_DIR}/dbl/platform/io/logging/logging.cmake)

=== debian/changelog ===
ros-indigo-threemxl (0.2.0-2trusty) trusty; urgency=high

  * Add getAcceleration and getLinearAcceleration and fix some wrong data handling
  * OSX Compile fixes (Hans Gaiser)

 -- Wouter Caarls <w.caarls@tudelft.nl>  Wed, 02 Jul 2014 03:00:00 -0000

ros-indigo-threemxl (0.1.8-2trusty) trusty; urgency=high

  * threemxl: moved sync read index to make room for extra analog inputs
  * threemxl: added documentation
  * threemxl: added C3mxl.h and CDynamixel.h convenience header files

 -- Wouter Caarls <w.caarls@tudelft.nl>  Mon, 13 Jan 2014 02:00:00 -0000

ros-indigo-threemxl (0.1.7-2trusty) trusty; urgency=high

  * threemxl: don't use explicit muParser path

 -- Wouter Caarls <w.caarls@tudelft.nl>  Wed, 09 Oct 2013 03:00:00 -0000

ros-indigo-threemxl (0.1.6-2trusty) trusty; urgency=high

  * threemxl: Add explicit transitive library dependencies

 -- Wouter Caarls <w.caarls@tudelft.nl>  Mon, 07 Oct 2013 03:00:00 -0000

ros-indigo-threemxl (0.1.5-2trusty) trusty; urgency=high

  * threemxl: splitting source and header files

 -- Wouter Caarls <w.caarls@tudelft.nl>  Mon, 07 Oct 2013 03:00:00 -0000

ros-indigo-threemxl (0.1.4-2trusty) trusty; urgency=high

  * threemxl: avoid making list out of CXX_FLAGS

 -- Wouter Caarls <w.caarls@tudelft.nl>  Fri, 27 Sep 2013 03:00:00 -0000

ros-indigo-threemxl (0.1.3-2trusty) trusty; urgency=high

  * threemxl: added pkg-config build dependency

 -- Wouter Caarls <w.caarls@tudelft.nl>  Thu, 26 Sep 2013 03:00:00 -0000

ros-indigo-threemxl (0.1.2-2trusty) trusty; urgency=high

  * threemxl: added system dependencies to package.xml

 -- Wouter Caarls <w.caarls@tudelft.nl>  Tue, 24 Sep 2013 03:00:00 -0000

ros-indigo-threemxl (0.1.1-2trusty) trusty; urgency=high

  * Added catkinized threemxl package

 -- Wouter Caarls <w.caarls@tudelft.nl>  Tue, 24 Sep 2013 03:00:00 -0000

=== debian/control ===
Source: ros-indigo-threemxl
Section: misc
Priority: extra
Maintainer: Wouter Caarls <w.caarls@tudelft.nl>
Build-Depends: debhelper (>= 9.0.0), libftdipp-dev, libmuparser-dev, libreadline-dev, libtinyxml-dev, pkg-config, ros-indigo-catkin, ros-indigo-roscpp, ros-indigo-shared-serial
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-threemxl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libftdipp-dev, libmuparser-dev, libreadline-dev, libtinyxml-dev, ros-indigo-roscpp, ros-indigo-shared-serial
Description: Dynamixel and 3mxl driver

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-threemxl//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
